import RPi.GPIO as GPIO
import time
GPIO.setmode(GPIO.BCM)

# Segment PGIO-Pins:
segA = 4
segB = 5
segC = 6
segD = 12
segE = 13
segF = 16
segG = 17

# Stellen GPIO-Pins:
dig1 = 22
dig2 = 23
dig3 = 24
dig4 = 25

# Alle Segment-Pins und Digit-Pins auf Output stellen:
for seg in [segA, segB, segC, segD, segE, segF, segG]:
	GPIO.setup(seg, GPIO.OUT, initial = False)
for dig in [dig1, dig2, dig3, dig4]:
	GPIO.setup(dig, GPIO.OUT, initial = True)

# Funktion zur Anzeige einer Dezimalziffer an einer bestimmten Stelle:
def zeigeZifferAnStelle(ziffer, stelle):
	# alle Segmente und Stellen ausschalten:
	for seg in [segA, segB, segC, segD, segE, segF, segG]:
		GPIO.output(seg,False)
	for dig in [dig1, dig2, dig3, dig4]:
		GPIO.output(dig,True)
	# gewuenschte Stelle einschalten:
	GPIO.output(stelle,False)
	# Segmente einschalten je nach zu anzuzeigender Dezimalziffer:
	if (ziffer == 0):
		for s in [segA, segB, segC, segD, segE, segF]:
			GPIO.output(s,True)
	if (ziffer == 1):
		for s in [segB, segC]:
			GPIO.output(s,True)
	if (ziffer == 2):
		for s in [segA, segB, segD, segE, segG]:
			GPIO.output(s,True)
	if (ziffer == 3):
		for s in [segA, segB, segC, segD, segG]:
			GPIO.output(s,True)
	if (ziffer == 4):
		for s in [segB, segC, segF, segG]:
			GPIO.output(s,True)
	if (ziffer == 5):
		for s in [segA, segC, segD, segF, segG]:
			GPIO.output(s,True)
	if (ziffer == 6):
		for s in [segA, segC, segD, segE, segF, segG]:
			GPIO.output(s,True)
	if (ziffer == 7):
		for s in [segA, segB, segC]:
			GPIO.output(s,True)
	if (ziffer == 8):
		for s in [segA, segB, segC, segD, segE, segF, segG]:
			GPIO.output(s,True)
	if (ziffer == 9):
		for s in [segA, segB, segC, segD, segF, segG]:
			GPIO.output(s,True)
# end zeigeZifferAnStelle()

print ("Strg+C beendet das Programm")
try:
	while True:
		# Text von Tastatur einlesen:
		s = raw_input("Bitte vierstellige Zahl eingeben:")
		z0 = int(s[3]) # Einer
		z1 = int(s[2]) # Zehner
		z2 = int(s[1]) # Hunderter
		z3 = int(s[0]) # Tausender
		# Zahl 500 mal anzeigen mit Multiplexing:
		# Ein Durchgang dauert 4 x 0.001s = 0.004s.
		# Die Zahl bleibt also 500 x 0.004s = 2s stehen.
		for i in range (1,500):
			# Alle Ziffern nacheinander kurz (0.001 s) aufblinken lassen:
			zeigeZifferAnStelle(z0,dig4)
			time.sleep(0.001)
			zeigeZifferAnStelle(z1,dig3)
			time.sleep(0.001)
			zeigeZifferAnStelle(z2,dig2)
			time.sleep(0.001)
			zeigeZifferAnStelle(z3,dig1)
			time.sleep(0.001)
	 # Bemerkung: die Tausender-Ziffer bleibt stehen. Klar wieso?
except KeyboardInterrupt:
	print("Programm abgebrochen.")
	GPIO.cleanup()

